package molpage.com;

import java.io.FileInputStream;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Iterator;
import java.io.StringWriter;

import sims.hibernate.*;

import java.lang.reflect.*;
import java.util.HashSet;
import java.util.Date;

/**
 *
 * <p>Title: </p>
 *
 * <p>Description:klasi lieto batch upload operacijas,
 *  lai nolasitu un izanalizetu tab-delimited data
 *    AddTopBatchUpload.jsp,AddMiddleBatchUpload.jsp,AddBottomBatchUpload.jsp,
 * </p>
 *
 * <p>Copyright: Copyright (c) 2008</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public final class BatchAnalyser implements Iterator{
  private UserHttpSess session;
  private FileInputStream fis = null;
  private int head = 0;
  private int tail = 0;
  private int bufSize = 16334;//49202;//65536;//32768;
  private byte buffer[] = new byte[bufSize];
  private boolean eol = false;
  private boolean eof = false;
  private boolean isError = false;
  private boolean isHeaderError = true;
  private boolean isZipError = false;
  private boolean isFtpFile = false;
  private boolean isFtpDirec = false;
  private boolean underFix = false;
  private String missingFieldName = null;
  private int level;
  private int maxcolumncount = 128;
  private int maxcolumncount05 = 64;
/*
  private static final String[] myParam = {
    "ALIQUOT",
    "NAME",
    "COMMENT",
    "DATA FILE",
    "PROTOCOL FILE"
  };

  private static final int[] myParamValue = {9,0,1,7,6};
*/
  private static final String[] errorMessage = {
      "ALIQUOT",                      //0
      "Parameter file read error",
      "Unknown keyword in header",
      "Unknown file type",
      "Invalid structure of header",
      "Missing field",                //5
      "Too many fields",
      "Duplicate ID",
      "Zip file not uploaded",
      "File not in zip",
      "Invalid aliquot id",            //10
      "Duplicate id in data base",
      "Unzip error",
      "Invalid value",
      "Sorry, unsupported type",
      "File not in directory",         //15
      "Mandatory value missing",
      "Mandatory keyword missing:",
      "File used repeatedly",          //18 24.OKT.2007
      "Object doesn't exist",
      "Missing top id",                //20
      "Missing middle id",
      "Missing bottom id",
      "Unused field",
      "Duplicate file type",
      "Insufficient user rights"
  };
  private int startNum = 5; //0-th /*position for aliquot_sysid*/
                            //1-st position for top
                            //2-nd position for middle
                            //3-rd position for owner rights
  private int sizeNum = startNum;
  private TempMetaData[] paramArray;
  private List<String[]> recordList = null;
  private List<byte[]> errorList = null;
  private Iterator recordIterator;
  private Iterator errorIterator;
  private byte[] headerError;
  private String[] headerRecord;
  private String[] myNextRecord;
  private int topNum = 0;
  private int middleNum = 0;
  private int bottomNum = 0;
  private int dataFileNum = 0;   //number of data files
  private int dataFileNum1;      //number of data files
  private String[] dataFileNames;
  private int protocolFileNum = 0;   //number of data files
  private int protocolFileNum1;      //number of data files
  private String[] protocolFileNames;
  private int[] fileToTypeKey;
  private String dataType = "0";
  private String protocolType = "0";
  private int generIds = 0;
  private int unrecIds = 0;
  private int duplicIds = 0;
  private File ftpFile = null;
  private File ftpDirec = null;
  private File tarFile = null;
  private int zipType = 0;   //1-zip; 2-gz;
   private String topId = null;
  private String middleId = null;
  private Top topEl = null;
  private Middle middleEl = null;
  private int generNum = 0;
  private String topRights = null;

  public BatchAnalyser( UserHttpSess tmpHttpSessObj, int level) {
// level: 0=top; 1=middle; 2=bottom;
    session = tmpHttpSessObj;
    this.level = level;
  }
//--------------- my lexer -----------------------------------------
  private int readByte() throws IOException{
      if (head >= tail){
          head = 0;
          tail = fis.read(buffer, head, bufSize);
          if (tail < 1) return -1;
      }
      return buffer[head++];
  }

  private String getLexem()throws IOException{
    StringWriter sw = new StringWriter(100);
    int b = readByte();
    while (b > 0){
      if (b == '\t') break;
      if (b == '\r' || b == '\n'){ eol = true; break;}
      sw.write(b);
      b = readByte();
    }
    if (b < 0) {eol = true; eof = true;}
    return sw.toString();
  }

  private void getStartOfLine() throws IOException{
    int b = '\r';
     while (b == '\r' || b == '\n') b = readByte();
    if (b < 0) {eof = true; eol = true;}
    else {eol = false; head--;}
  }

  private void flashLine()throws IOException{
    int b = 1;
    while (b > 0){
      if (b == '\r' || b == '\n') break;
      b = readByte();
    }
    eol = true;
    if ( b <= 0 ) eof = true;
  }
  private String findKey( String pName){
	int j = pName.indexOf('#');
	String key = (j < 3) ? "" : pName.substring(j);
	return key;
  }
  private int addTypeKey( String key, String[] keys, int keyCount){
    for (int i = 0; i < keyCount; i++){
      if (key.equals(keys[i])) return i;
    }
    keys[ keyCount] = key; return keyCount;
  }
 
//---------------------------------------------------------
  /**
   * noolasa un parbauda batch upload header
   * @throws Exception
   */
  public void startOfAnalysis() throws Exception {    //get header
    File paramFile = session.getParameterTempFile();
    headerError = new byte[maxcolumncount];     //maxcolumncount = 64
    headerRecord = new String[maxcolumncount];
    paramArray = new TempMetaData[maxcolumncount];

    String[] dataTypeKey = new String[maxcolumncount05];
    String[] protTypeKey = new String[maxcolumncount05];
    fileToTypeKey = new int[maxcolumncount];
    for (int k = 0; k < maxcolumncount; k++) fileToTypeKey[k] = -1;
    int[] keyToDataType = new int[maxcolumncount05];
    for (int k = 0; k < maxcolumncount05; k++) keyToDataType[k] = -1;
    int[] keyToProtType = new int[maxcolumncount05];
    for (int k = 0; k < maxcolumncount05; k++) keyToProtType[k] = -1;
    int dataTypeKeyCount = 0;
    int protTypeKeyCount = 0;
    int wNum;

    MetadataManager mdm = session.getMetadataManager();
    mdm.clearTempColumnNumber( level);
    for (int i = 0; i < maxcolumncount; i++) headerError [i] = 0;
    if (paramFile==null){
      headerError[sizeNum] = 1;
      isError = true;
      return;
    }
    try{
      fis = new FileInputStream(paramFile);
      getStartOfLine();
      while (!eol){
        TempMetaData tmd;
        String lex = getLexem();
        headerRecord[sizeNum] = lex;
        int myLevel = -1; 
        int k = lex.indexOf('.');
        if (k > 0) {  //test prefix
          String prefix = lex.substring(0, k + 1).trim();
          if (prefix.equals( VocabulName.getTopPrefix())){
            myLevel = 0;
          } else
          if (prefix.equals( VocabulName.getMiddlePrefix())){
            myLevel = 1;
          } else
          if (prefix.equals( VocabulName.getBottomPrefix())){
            myLevel = 2;
          }
          if ( myLevel >= 0) {
            lex = lex.substring(k + 1);  //upload name
          }
        }
        lex = lex.trim();
        if (myLevel<0) myLevel = level;
        tmd = mdm.findParameter( myLevel, lex);
        if (tmd!=null){
          tmd.setTempColumnNumber(sizeNum);
          int num = tmd.getValueRowNumber();
          switch( num){
            case Fieldname.DATAFILESnum: dataFileNum++;;
            wNum = addTypeKey( findKey(lex), dataTypeKey, dataTypeKeyCount);
            if (wNum==dataTypeKeyCount) dataTypeKeyCount++;
            fileToTypeKey[ sizeNum] = wNum;
            break;
            case Fieldname.PROTOCOLnum: protocolFileNum++; 
            wNum = addTypeKey( findKey(lex), protTypeKey, protTypeKeyCount);
            if (wNum==protTypeKeyCount) protTypeKeyCount++;
            fileToTypeKey[ sizeNum] = wNum;
            break;
            case Fieldname.DATAFILESTYPEnum: 
            wNum = addTypeKey( findKey(lex), dataTypeKey, dataTypeKeyCount);
            if (wNum==dataTypeKeyCount) dataTypeKeyCount++;
            if (keyToDataType[ wNum]!=-1){isError = true; headerError[sizeNum] = 24;}
            else
            keyToDataType[ wNum] = sizeNum;
            break;
            case Fieldname.PROTOCOLTYPEnum: 
            wNum = addTypeKey( findKey(lex), protTypeKey, protTypeKeyCount);
            if (wNum==protTypeKeyCount) protTypeKeyCount++;
            if (keyToProtType[ wNum]!=-1){isError = true; headerError[sizeNum] = 24;}
            else
            keyToProtType[ wNum] = sizeNum;
            break;
          }
          if (num==0){ //Fieldname.VISIBLENAMEnum
            if (myLevel==0) topNum = sizeNum;
            if (myLevel==1) middleNum = sizeNum;
            if (myLevel==2) bottomNum = sizeNum;
        	if (generIds > 0) headerError[sizeNum] = 123;
          }	else {
        	if (myLevel!=level){  
              tmd = null;
              if (unrecIds==0) {isError = true; headerError[sizeNum] = 2;}
              else headerError[sizeNum] = 102;
        	}  
          }
          paramArray[sizeNum] = tmd;
        } else {  //tmd==null
           if (unrecIds==0) {isError = true; headerError[sizeNum] = 2;}
           else headerError[sizeNum] = 102;
        }
        if (++sizeNum==(maxcolumncount-1)) break;
      }
    } catch ( Exception ex ){
//      headerError[sizeNum] = 1;
      throw ex;
    }

    for (int k = startNum; k <= sizeNum; k++){
      TempMetaData param = paramArray[k];
      if (param!=null){
        int num = param.getValueRowNumber();
        if (num==Fieldname.DATAFILESnum){
          int j = fileToTypeKey[ k];
          int l = keyToDataType[ j];
          fileToTypeKey[ k] = l;  //may be -1
          if (l>=0) fileToTypeKey[ l] = 1;  
        } else
        if (num==Fieldname.PROTOCOLnum){
          int j = fileToTypeKey[ k];
          int l = keyToProtType[ j];
          fileToTypeKey[ k] = l;  //may be -1
          if (l>=0) fileToTypeKey[ l] = 1; 
        }
      }
    }
    for (int k = startNum; k <= sizeNum; k++){
        TempMetaData param = paramArray[k];
        if (param!=null){
          int num = param.getValueRowNumber();
          if (num==Fieldname.DATAFILESTYPEnum){
            int j = fileToTypeKey[ k];
            if (j < 0) headerError[k] = 123;
          } else
          if (num==Fieldname.PROTOCOLTYPEnum){
            int j = fileToTypeKey[ k];
            if (j < 0) headerError[k] = 123;
          }
        }
      }
    
    // test some errors
    if (underFix && topEl==null){headerError[sizeNum] = 20; isError = true;}
    if (underFix && level==2 && middleEl==null){headerError[sizeNum] = 21; isError = true;}
    if (generIds == 0){
      if (level==0){	
        if (topNum==0) headerError[ sizeNum] = 20;	
        if (middleNum!=0) headerError[middleNum] = 123;	
        if (bottomNum!=0) headerError[bottomNum] = 123;	
      }
      else
      if (level==1){
    	if (underFix){
    	  if (topNum!=0)headerError[topNum] = 123;
    	} else {
       	  if (topNum==0)headerError[sizeNum] = 20;
    	}  
        if (middleNum==0) headerError[ sizeNum] = 21;	
        if (bottomNum!=0) headerError[bottomNum] = 123;
      }
      else
      if (level==2){
      	if (underFix){
      	  if ( topNum!=0)headerError[topNum] = 123;
      	  if ( middleNum!=0)headerError[middleNum] = 123;
      	} else {
          if ( topNum==0)headerError[sizeNum] = 20;
          if ( middleNum==0)headerError[sizeNum] = 21;
      	}    	  
        if (bottomNum==0) headerError[sizeNum] = 22;
      }
    }
    if (sizeNum==(maxcolumncount-1)) headerError[sizeNum] = 4;
    missingFieldName = mdm.checkRequiredParameter( level);
    if (missingFieldName!=null) headerError[sizeNum] = 17;
    if (headerError[sizeNum] > 0) isError = true;
    isHeaderError = isError;
  }
  /**
   *  nolasa un parbauda batch upload datus
   *
   */
  public void endOfAnalysis()throws Exception { //test all rows
    HashSet<String>fileNames = new HashSet<String>();
    String[]filex = null;
    int iFilex;
    File zipFile = (isFtpDirec)?null:(isFtpFile)?ftpFile:session.getZipTempFile();
    ZipProcessor zipProc = null;
    recordList = new ArrayList<String[]>();
    errorList = new ArrayList<byte[]>();
    if (fis==null) return;
    if (dataFileNum > 0 || protocolFileNum > 0){
      filex = new String[dataFileNum+protocolFileNum];	
      if (zipType>0 && zipFile!=null) zipProc = new ZipProcessor( zipFile, zipType);
    }
    try{
      getStartOfLine();
      while (!eof){
        String[] myRecord = new String[sizeNum];
        myRecord[0]=""; myRecord[1]=topId;  myRecord[2]=middleId; myRecord[3]=topRights;
        byte[] myError = new byte[sizeNum + 1];
        iFilex = 0;
        for (int k = 0; k <= sizeNum; k++) myError[k] = 0;
        for (int k = startNum; k < sizeNum; k++){
          if (eol) {//to few
            myError[k] = 5; isError = true;
            myRecord[k] = "error";
          } else {
            String lex = getLexem().trim();
            if (k==topNum){
            	if (topEl!=null) myError[topNum] = 123;
            } else
            if (k==middleNum){
            	if (middleEl!=null) myError[middleNum] = 123;
            } else
            if (k!=bottomNum){
              TempMetaData param = paramArray[k];
              if (param == null) { //unknown keyword
                if (unrecIds==0) {isError = true; myError[k] = 2;}
                else myError[k] = 102;
              }
              else {
                int num = param.getValueRowNumber();
//                Util.writeLog("endOfAnalysisRownum",
//                          lex,
//                          String.valueOf(num));
                switch (num) {
                case Fieldname.PROTOCOLTYPEnum: //protfile type
                    if (lex.equals(""))break; //empty value valid for all types
                    ProtocolType obj1 =
                        (ProtocolType)session.getObjectByName(ProtocolType.class, lex);
                    if (obj1 == null){
                      myError[k] = 3;
                      isError = true; //
                    } else
                     lex = lex + '\r' + String.valueOf(obj1.getId());
                    break;
                  case Fieldname.DATAFILESTYPEnum: //data file type
                    if (lex.equals(""))break; //empty value valid for all types
                    DataType obj2 = (DataType)session.getObjectByName(DataType.class, lex);
                    if (obj2 == null){
                      myError[k] = 3;
                      isError = true; //
                    } else
                     lex = lex + '\r' + String.valueOf(obj2.getId());
                    break;
                  case Fieldname.DATAFILESnum: //data file
                    if (lex.equals(""))break; //empty value valid for all types
                    if (fileNames.contains(lex)) {
                      myError[k] = 18; //repeated use
                      isError = true; //
                      break;
                    }
                    for (int i = 0; i < iFilex; i++)
                      if (lex.equals(filex[i])){	
                        myError[k] = 18; //repeated use
                        isError = true; //
                        break;
                      }
                    filex[iFilex++]=lex;
//                    fileNames.add(lex);
                    if (isFtpDirec) {
                      File tfile = new File(ftpDirec, lex);
                      if (!tfile.exists()) {
                        myError[k] = 15;
                        isError = true; //
                      }
                    }
                    else
                    if (zipProc == null) {
                      isZipError = true;
                    }
                    else { //zip file (local or ftp)
                      Integer zipNum = zipProc.existsFile(lex);
                      if (zipNum == null) {
                        myError[k] = 9;
                        isError = true; //
                      }
                      else
                      if (isFtpFile) lex = lex + '\r' + zipNum.toString();
                    }
                    break;   //data file
                  case Fieldname.PROTOCOLnum: //protocol file
                      if (lex.equals(""))break; //empty value valid for all types
                      if (fileNames.contains(lex)) {
                        myError[k] = 18; //repeated use
                        isError = true; //
                        break;
                      }
                      for (int i = 0; i < iFilex; i++)
                        if (lex.equals(filex[i])){	
                          myError[k] = 18; //repeated use
                          isError = true; //
                          break;
                        }
                      filex[iFilex++]=lex;
//                      fileNames.add(lex);
                      if (isFtpDirec) {
                        File tfile = new File(ftpDirec, lex);
                        if (!tfile.exists()) {
                          myError[k] = 15;
                          isError = true; //
                        }
                      }
                      else
                      if (zipProc == null) {
                        isZipError = true;
                      }
                      else { //zip file (local or ftp)
                        Integer zipNum = zipProc.existsFile(lex);
                        if (zipNum == null) {
                          myError[k] = 9;
                          isError = true; //
                        }
                        else
                        if (isFtpFile) lex = lex + '\r' + zipNum.toString();
                      }
                      break;   //protocol file
                  default:   //all other
                    if (lex.equals("")) {
                      if (param.isRequired()) {
                        myError[k] = 16;
                        isError = true;
                      }
                      break;
                    } //empty value valid for all types
                    if (num > VocabulName.getIdentificyFirst()) { //Fxxx
                      int baseType = param.getBaseType();
//                      Util.writeLog("endOfAnalysisBaseType",
//                                lex,
//                                String.valueOf(baseType));
                      if (baseType == TypeName.NUMBER) {
                        if (!Util.checkIntegerValue(lex)) {
                          myError[k] = 13;
                          isError = true;
                        }
                      }
                      else if (baseType == TypeName.FLOAT) {
                        if (!Util.checkFloatValue(lex)) {
                          myError[k] = 13;
                          isError = true;
                        }
                      }
                      else if (baseType == TypeName.BOOLEAN) {
                        if (!Util.checkBooleanValue(lex)) {
                          myError[k] = 13;
                          isError = true;
                        }
                      }
                      else if (baseType == TypeName.DATETIME) {
                        if (!Util.checkDateTimeValue(lex, 2)){
                          myError[k] = 13;
                          isError = true;
                        }
                      }
/*
                      else if (baseType == TypeName.TIME) {
                        lex = lex + ',';
                        alex = Util.checkTimeValue(lex, param.getAttribute1());
                        if (alex == null) {
                          myError[k] = 13;
                          isError = true;
                        }
                        else lex = lex + '\r' + alex;
                      }
*/
                      else if (baseType == TypeName.TABLE || baseType == TypeName.IDENTIFICY) {
                        Long sid = session.
                              checkObjectByName( param.getBaseClass(), lex);
                        if (sid==null){
                          myError[k] = 13;
                          isError = true;
                        }
                        else lex = lex + '\r' + sid.toString();
                      }
                    }
                }
              }
            }
            myRecord[k] = lex;
          }
        }
        if (!eol) { //to much
          flashLine();
          myError[sizeNum] = 6;
          isError = true;
        }
//----------------------------------------------------------------
//----------------------------------------------------------------
//        if (generIds > 0){
        Long sid = null;
        Top myTop;
        String persIdent = null;
        String samplIdent = null;
        String aliqIdent= null;
//----------------------------------------------------------------
        if (generIds>0){
          if (topNum>0) myError[topNum] = 123; 
          if (middleNum>0) myError[middleNum] = 123; 
          if (bottomNum>0) myError[bottomNum] = 123; 
        } else {
          if (topNum > 0 && !underFix/*&& level < 2*/) { //
            persIdent = myRecord[topNum];
            int checkP = session.checkPersonId( persIdent);
            if (level==0 && checkP == 3){
              if (duplicIds>0){myError[topNum] = 107;myRecord[0]="DUPL";}
              else {myError[topNum] = 7; isError = true;}
            } else
            if (level==0 && checkP != 0){
              myError[topNum] = 20; //missing
              isError = true;
            } else
            if (level>0 && checkP != 3){
              myError[topNum] = 20; //not exists
              isError = true;
            } else {
              Iterator iter = recordList.iterator();
              boolean found = false;
              while (iter.hasNext()) {
                String[] record = (String[]) iter.next();
                if (record[topNum].equals(persIdent)) {
                  myRecord[1] = record[1]; myRecord[3] = record[3];
                  found = true;
                  if (level==0){
                    if (duplicIds>0){myError[topNum] = 111;myRecord[0]="DUPL";}
                          else {myError[topNum] = 11; isError = true;}
                  } else
                  if (myRecord[1] == null) {
                    myError[topNum] = 19; //not exists
                    isError = true;
                  } else
                  if (myRecord[3]==null||!myRecord[3].equals("OK")) {
                    myError[topNum] = 25; //unsuff rights
                    isError = true;
                  }
                  break;
                }
              }
              if (!found) {
               myTop = session.getTopElement( persIdent);
                if (myTop == null) {
                  myRecord[1] = null;
                  if (level > 0) {
                    myError[topNum] = 19; //not exists
                    isError = true;
                  }
                } else {
                  myRecord[1] = myTop.getId().toString();
                  myRecord[3] = (session.getGrantedRights( myTop)<3000)?"INSUF":"OK";
                  if (level == 0) {
                    if (duplicIds>0){myError[topNum] = 111;myRecord[0]="DUPL";}
                    else {myError[topNum] = 11; isError = true;}
                  } else
                    if (myRecord[3]==null||!myRecord[3].equals("OK")) {
                      myError[topNum] = 25; //unsuff rights
                      isError = true;
                  }
                }
              }
            }
          }
//----------------------------------------------------------------
          if (middleNum > 0 && myRecord[1]!=null && (level==1 || (level==2 && !underFix))){
            samplIdent = myRecord[middleNum];
            if (samplIdent==null||samplIdent.equals("")/* ||
              (persI!=null && !samplIdent.startsWith(persI))*/) {
              myError[middleNum] = 21; //missing
              isError = true;
            } else {
              Iterator iter = recordList.iterator();
              boolean found = false;
              while (iter.hasNext()) {
                String[] record = (String[]) iter.next();
                if (record[middleNum].equals(samplIdent) && myRecord[1].equals(record[1])){
                  myRecord[2] = record[2];
                  found = true;
                  if (level==1){
                    if (duplicIds>0){myError[middleNum] = 111;myRecord[0]="DUPL";}
                            else {myError[middleNum] = 11; isError = true;}
                  } else
                  if (myRecord[2] == null && level == 2) {
                    myError[middleNum] = 19; //not exists
                    isError = true;
                  }
                  break;
                }
              }
              if (!found) {
                sid = session.getMiddleElementId(new Long(myRecord[1]), samplIdent);
                if (sid == null) {
                  myRecord[2] = null;
                  if (level == 2) {
                    myError[middleNum] = 19; //not exists
                    isError = true;
                  }
                } else {
                  myRecord[2] = sid.toString();
                  if (level == 1) {
                    if (duplicIds>0){myError[middleNum] = 111;myRecord[0]="DUPL";}
                    else {myError[middleNum] = 11; isError = true;}
                  }
                }
              }
            }
          }
//----------------------------------------------------------------
          if (bottomNum > 0 && level > 1 && myRecord[2]!=null){
            aliqIdent = myRecord[bottomNum];
//            Util.writeLog("BottomNum", String.valueOf(bottomNum), aliqIdent);
            if (aliqIdent == null || aliqIdent.equals("")/* ||
                (samplIdent!=null && !aliqIdent.startsWith(samplIdent))*/) {
              myError[bottomNum] = 22; //not exists
              isError = true;
            } else {
              Iterator iter = recordList.iterator();
              boolean found = false;
              while (iter.hasNext()) {
                String[] record = (String[]) iter.next();
                if (record[bottomNum].equals(aliqIdent) && myRecord[2].equals(record[2])){
                  found = true;
                  if (duplicIds>0){myError[bottomNum] = 111;myRecord[0]="DUPL";}
                  else {myError[bottomNum] = 11; isError = true;}
                }
              }
              if (!found) {
                sid = session.getBottomElementId(new Long(myRecord[2]), aliqIdent);
                if (sid != null) {
                  if (duplicIds>0){myError[bottomNum] = 111;myRecord[0]="DUPL";}
                  else {myError[bottomNum] = 11; isError = true;}
                }
              }
            }
          }
        }   //generIds==0
        if (!myRecord[0].equals("DUPL")){
          for (int i = 0; i < iFilex; i++) fileNames.add(filex[i]);  
        }
        recordList.add(myRecord);
        errorList.add(myError);
        getStartOfLine();
      }
    } catch ( Exception ex ){
//	    Util.writeLog("An error occured in the bean. Error Message is:",
//	    		ex.getMessage(), session.getHttpSessId());
      throw ex;
//      isError = true; return;
    }
    
/*    finally {
      try{ fis.close();
           if (zipProc!=null) zipProc.closeFile();}catch(IOException ex){}
    }*/
  }
//-----------------------------------------------------------------
  private int findZipType( String fileName){
    int result = 0;
	int j = fileName.lastIndexOf('.');
	if ( j > 0){
	  String ext = fileName.substring(j + 1);
	  if (ext.equals("zip")||ext.equals("ZIP")) result = 1;
	  else
	  if (ext.equals("gz")||ext.equals("GZ")) result = 2;
	}  
    return result;
  }
  public void takeRequest( RequestParser requestI){
    String val1 = requestI.getParameter("protocolfileType");
    if (val1!= null) protocolType = val1;
    val1 = requestI.getParameter("datafileType");
    if (val1!= null) dataType = val1;
    
    if (level==2){
      val1 = requestI.getParameter("understd");
      if (val1.equals("0")){ underFix = true;
        topId = requestI.getParameter("top");
        middleId = requestI.getParameter("middle");
        topEl = (Top)session.getObjectById( Top.class, topId); 
        middleEl = (Middle)session.getObjectById( Middle.class, middleId); 
        topRights = ((topEl!=null)&&(session.getGrantedRights( topEl)>=3000))?"OK":"INSUF";
      }
    }
    else
    if (level==1){
      val1 = requestI.getParameter("understd");
      if (val1.equals("0")){ underFix = true;
         topId = requestI.getParameter("top");
         topEl = (Top)session.getObjectById( Top.class, topId); 
         topRights = ((topEl!=null)&&(session.getGrantedRights( topEl)>=3000))?"OK":"INSUF";
      }
    }
    val1 = requestI.getParameter("ftpfile");
    if (val1 !=null && !val1.equals("")){
      isFtpFile = true;
      ftpFile = new File( UserHttpSess.getFtpDirectory(),val1);
      zipType = findZipType( val1); 
    }
    val1 = requestI.getParameter("ftpdirec");
    if (val1!=null){
      isFtpDirec = true;
      ftpDirec = new File( UserHttpSess.getFtpDirectory(), val1);
    }
    val1 = requestI.getParameter("zipfile");
    if (val1 !=null && !val1.equals("")){
      zipType = findZipType( val1); 
    }
    generIds = Util.getInt(requestI.getParameter("gener_ids"));
    unrecIds = Util.getInt(requestI.getParameter("unrec_ids"));
    duplicIds = Util.getInt(requestI.getParameter("duplic_ids"));
  }
  public boolean getUnderFix(){
    return underFix ;
  }
  public Top getTopElement(){
	return topEl;
  }
  public Middle getMiddleElement(){
	return middleEl;
  }
  public int getGenerIds(){
    return generIds ;
  }

  private void appendString( StringBuffer xyz, String value){
    for (int i = 0; i < value.length(); i++){
      char c = value.charAt(i);
      switch(c){
        case '<': xyz.append("&lt;"); break;
        case '>': xyz.append("&gt;"); break;
        default : xyz.append(c);
      }
    }
  }
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
  public String getHeaderHTML(){
    StringBuffer xyz = new StringBuffer();
    for (int i = startNum; i < sizeNum; i++){
      if (headerError[i]>100)
        xyz.append("<th id=\"bridin\" title=\"")
           .append(errorMessage[headerError[i]-100])
           .append("\">");
      else
      if (headerError[i]>0)
        xyz.append("<th id=\"kluda\" title=\"")
           .append(errorMessage[headerError[i]])
           .append("\">");
      else
        xyz.append("<th>");
        appendString( xyz, headerRecord[i]);
        xyz.append("</th>");
    }
    if (headerError[sizeNum] > 0){
      xyz.append("<th id=\"kluda\" title=\"");
      if (headerError[sizeNum] == 22)
        xyz.append("Missing ")
          .append(VocabulName.getBottomSingular())
          .append(" id");
      else
      if (headerError[sizeNum] == 21)
        xyz.append("Missing ")
          .append(VocabulName.getMiddleSingular())
          .append(" id");
      else
      if (headerError[sizeNum] == 20)
        xyz.append("Missing ")
          .append(VocabulName.getTopSingular())
          .append(" id");
      else
        xyz.append(errorMessage[headerError[sizeNum]]);
      if (headerError[sizeNum] == 17)
        xyz.append(missingFieldName);
      xyz.append("\">error</th>");
    }
    return xyz.toString();
  }
//----------------------------------------------------------
  public String getHeaderString(){
    StringBuffer xyz = new StringBuffer();
    boolean ef = false;
    for (int i = startNum; i < sizeNum; i++){
      xyz.append(headerRecord[i]);
      if (headerError[i]>100)
        xyz.append("<warning:")
           .append(errorMessage[headerError[i]-100])
           .append(">");
      else
      if (headerError[i]>0){
        ef = true;
        xyz.append("<error:")
            .append(errorMessage[headerError[i]])
            .append(">");
      }
      xyz.append('\t');
    }
    if (headerError[sizeNum] > 0){
      if (headerError[sizeNum] == 22)
        xyz.append("<error:Missing ")
          .append(VocabulName.getBottomSingular())
          .append(" id");
      else
      if (headerError[sizeNum] == 21)
        xyz.append("<error:Missing ")
          .append(VocabulName.getMiddleSingular())
          .append(" id");
      else
      if (headerError[sizeNum] == 20)
        xyz.append("<error:Missing ")
          .append(VocabulName.getTopSingular())
          .append(" id");
      else
      xyz.append("<error:")
          .append(errorMessage[headerError[sizeNum]]);
      if (headerError[sizeNum] == 17)
        xyz.append(missingFieldName);
      xyz.append(">");
    }
    else
    if (ef)
      xyz.append("NOK");
    else
      xyz.append("OK");
    return xyz.toString();
  }


//----------------------------------------------------------
//---------Iterator while create HTML---------------------
//----------------------------------------------------------
  public Iterator iterator(){
    recordIterator = recordList.iterator();
    errorIterator = errorList.iterator();
    return this;
  }

  public boolean hasNext(){
    return recordIterator.hasNext();
  }

  public Object next(){
    StringBuffer xyz = new StringBuffer();
    String[] myRecord = (String[])recordIterator.next();
    byte[] myError = (byte[])errorIterator.next();
    for (int i = startNum; i < sizeNum; i++){
      if (myError[i]>100)
        xyz.append("<td id=\"bridin\" title=\"")
           .append(errorMessage[myError[i]-100])
           .append("\">");
      else
      if (myError[i]>0)
        xyz.append("<td id=\"kluda\" title=\"")
           .append(errorMessage[myError[i]])
           .append("\">");
      else
        xyz.append("<td>");
      String value = myRecord[i];
      if (value.equals("")) xyz.append("&nbsp;");
      else {
        int l = value.indexOf('\r');
        if (l > 0)
          appendString(xyz, value.substring(0, l));
        else
          appendString(xyz, value);
      }
      xyz.append("</td>");
    }
    if (myError[sizeNum] > 0)
      xyz.append("<td id=\"kluda\" title=\"")
         .append(errorMessage[myError[sizeNum]])
         .append("\">error</td>");
    return xyz.toString();
  }

  public void remove(){
  }
//----------------------------------------------------------
//----------------------------------------------------------
  public boolean isError(){
    return isError;
  }

  public boolean isHeaderError(){
    return isHeaderError;
  }

  public boolean isZipError(){
    return isZipError;
  }
//----------------------------------------------------------
//---------Iterator while create objects---------------------
//----------------------------------------------------------
  public void startIterator(){
    recordIterator = recordList.iterator();
    if (dataFileNum>0)
      dataFileNames = new String[dataFileNum];
    if (protocolFileNum>0)
        protocolFileNames = new String[protocolFileNum];
    if (level==0 && generIds > 0)
    	generNum = session.getTopIdentifierNum();
    if (zipType==2 && !isFtpFile){
    	tarFile = session.newTarTempFile();
    	ZipProcessor.expandGZipFile(session.getZipTempFile(), tarFile);
    }  
  }

  public boolean hasNextElement(){
    boolean xyz = recordIterator.hasNext();
    while (xyz){
      myNextRecord = (String[])recordIterator.next();
      if (!myNextRecord[0].equals("DUPL"))break;
      xyz = recordIterator.hasNext();
    }  
    return xyz;
  }

  private void setTargetValue( String value, TempMetaData param, Object target) throws Exception {
    Class targetClass = target.getClass();
    int baseType = param.getBaseType();
    if (baseType==TypeName.STRING){
      Class[] paramTypes = {String.class};
      Method meth = targetClass.getMethod( param.getSetMethodName(), paramTypes);
      Object[] args = {value};
      meth.invoke(target, args);
    }
    else
    if (baseType==TypeName.NUMBER){
      Integer ivalue = Util.getInteger(value);
      Class[] paramTypes = {Integer.class};
      Method meth = targetClass.getMethod( param.getSetMethodName(),
                                          paramTypes);
      Object[] args = {ivalue};
      meth.invoke(target, args);
    }
    else
    if (baseType==TypeName.FLOAT){
      Double fvalue = Util.getFloat(value);
      Class[] paramTypes = {Double.class};
      Method meth = targetClass.getMethod( param.getSetMethodName(),
                                           paramTypes);
      Object[] args = {fvalue};
      meth.invoke(target, args);
    }
    else
    if (baseType==TypeName.TABLE || baseType==TypeName.IDENTIFICY){
      int l = value.indexOf('\r');
      String idstr = value.substring(l+1);
      Class xyz = param.getBaseClass();
      Persistent myObj = (Persistent) session.getObjectById(xyz, idstr);
      Class[] paramTypes = {xyz};
      Method meth = targetClass.getMethod( param.getSetMethodName(),
                                           paramTypes);
      Object[] args = {myObj};
      meth.invoke(target, args);
    }
    else if (baseType == TypeName.DATETIME) {
      Date dvalue = Util.getDateTimeValue(value, 2);
      Class[] paramTypes = {Date.class};
      Method meth = targetClass.getMethod( param.getSetMethodName(),
                                           paramTypes);
      Object[] args = {dvalue};
      meth.invoke(target, args);
    }
  }

/*
  private void setTargetParameters( String value, int type, Object target) throws Exception {
    Class targetClass = target.getClass();
    for (int i = 1; i <= VocabulName.getIdentificyCount(); i++) {
      String key = VocabulName.getFieldNameIVT(i);
      if (mdm.hasField(type, key)) {
        if (value!=null){
          Class xyz = VocabulName.getIdentificyClass(i);
          Persistent myObj = (Persistent) getObjectById(xyz, value);
          Class[] paramTypes = {xyz};
          Method meth = targetClass.getMethod(VocabulName.getSetMethodNameIVT(i),
                                              paramTypes);
          Object[] args = {myObj};
          meth.invoke(target, args);
        }
      }
    }

    for (int i = 1; i <= VocabulName.getVocabularyCount(); i++) {
      String key = VocabulName.getFieldNameVT(i);
      if (mdm.hasField(type, key)) {
        String value = request.getParameter(key);
        Class xyz = Class.forName(VocabulName.getClassNameVT(i));
        Persistent myObj = (Persistent) getObjectById(xyz, value);
        Class[] paramTypes = {xyz};
        Method meth = targetClass.getMethod(VocabulName.getSetMethodNameVT(i),
                                          paramTypes);
        Object[] args = {myObj};
        meth.invoke( target, args);
      }
    }

    for (int i = 1; i <= VocabulName.getDateCount(); i++) {
      String itxx = VocabulName.getFieldNameDT(i);
      if (mdm.hasField( type, itxx)) {
        Date dvalue = getDate(request, itxx);
        Class[] paramTypes = {Date.class};
        Method meth = targetClass.getMethod(VocabulName.getSetMethodNameDT(i),
                       paramTypes);
        Object[] args = {dvalue};
        meth.invoke(target, args);
      }
    }
  }
*/
  public void nextElement( Bottom tempBottom) throws Exception {
    String[] myRecord = myNextRecord;
    String dataFiles ="\r";
    String protocolFiles ="\r";
    dataFileNum1 = 0;
    protocolFileNum1 = 0;
    int pendingCount = 0;
    Middle stg = middleEl;
    if (stg==null && myRecord[2]!=null)
      stg = (Middle)session.getObjectById(Middle.class,myRecord[2]);
    tempBottom.setParent( stg);
    for (int k = startNum; k < sizeNum; k++){
      String value = myRecord[k];
      TempMetaData param = paramArray[k];
      if (param==null) continue;    //unknown keyword
      int num = param.getValueRowNumber();
      switch(num){
        case 0: if (k==bottomNum) tempBottom.setVisibleName(value); break;
        case 1: tempBottom.setComment(value); break;
        case Fieldname.DATAFILESnum: if (!value.equals("")){  //datafile
          dataFileNames[ dataFileNum1++] = value;
          if (isFtpFile){
            int l = value.indexOf('\r');
            value = value.substring( 0,l);
          }
          String typname = dataType;
          int m = fileToTypeKey[k];
          if (m >= 0){
            typname = myRecord[m];
            if (!typname.equals("")){
              int l = typname.indexOf('\r');
              if (l>0)typname = typname.substring( l+1);
            }
          }
          dataFiles += FileString.getNewContents(value, typname, dataFileNum1);
          if (isFtpDirec || isFtpFile) pendingCount++;
          }
          break;
        case Fieldname.PROTOCOLnum: if (!value.equals("")){  //protocolfile
          protocolFileNames[ protocolFileNum1++] = value;
          if (isFtpFile){
            int l = value.indexOf('\r');
            value = value.substring( 0,l);
          }
          String typname = protocolType;
          int m = fileToTypeKey[k];
          if (m >= 0){
            typname = myRecord[m];
            if (!typname.equals("")){
              int l = typname.indexOf('\r');
              if (l>0)typname = typname.substring( l+1);
            }
          }
          protocolFiles += FileString.getNewContents(value, typname, protocolFileNum1);
          if (isFtpDirec || isFtpFile) pendingCount++;
          }
          break;
        default: if (num > VocabulName.getIdentificyFirst()){
          try {
            setTargetValue( value, param, tempBottom);
          }
          catch (Exception ex) {}
        }
      }
    }
    if (generIds > 0 && stg != null){
        int identCount = VocabulName.getLevelIdCount(level);
        long identificId[] = new long[identCount];
        for (int i=0; i<identCount; i++){
     		String fn = VocabulName.getFieldNameIVT(VocabulName.getLevelIdNum( level,i));
          Persistent identific = (Persistent) tempBottom.getValue( fn);
          identificId[ i] = (identific!=null)?identific.getId().longValue():0;
        }  
        String genId = session.getSimsIdentifierTemp( level, stg.getId().toString(),
        		stg.getVisibleName(),identificId, "0");
    	tempBottom.setVisibleName( genId);
    }
    if (dataFileNum1>0) tempBottom.setDataFiles(dataFiles);
    if (protocolFileNum1>0) tempBottom.setProtocolFiles(protocolFiles);
    tempBottom.setPendingX(new Integer( pendingCount));
  }
  public void nextElement( Middle tempMiddle) throws Exception {
    String[] myRecord = myNextRecord;
    String dataFiles ="\r";
    String protocolFiles ="\r";
    dataFileNum1 = 0;
    protocolFileNum1 = 0;
    int pendingCount = 0;
    Top stg = topEl;
    if (stg==null && myRecord[1]!=null)
      stg = (Top)session.getObjectById(Top.class,myRecord[1]);
    tempMiddle.setParent( stg);
    for (int k = startNum; k < sizeNum; k++){
      String value = myRecord[k];
      TempMetaData param = paramArray[k];
      if (param==null) continue;    //unknown keyword
      int num = param.getValueRowNumber();
      switch(num){
        case 0: if (k==middleNum) tempMiddle.setVisibleName(value); break;
        case 1: tempMiddle.setComment(value); break;
        case Fieldname.DATAFILESnum: if (!value.equals("")){  //datafile
          dataFileNames[ dataFileNum1++] = value;
          if (isFtpFile){
            int l = value.indexOf('\r');
            value = value.substring( 0,l);
          }
          String typname = dataType;
          int m = fileToTypeKey[k];
          if (m >= 0){
            typname = myRecord[m];
            if (!typname.equals("")){
              int l = typname.indexOf('\r');
              if (l>0)typname = typname.substring( l+1);
            }
          }
          dataFiles += FileString.getNewContents(value, typname, dataFileNum1);
          if (isFtpDirec || isFtpFile) pendingCount++;
          }
          break;
        case Fieldname.PROTOCOLnum: if (!value.equals("")){  //protocolfile
          protocolFileNames[ protocolFileNum1++] = value;
          if (isFtpFile){
            int l = value.indexOf('\r');
            value = value.substring( 0,l);
          }
          String typname = protocolType;
          int m = fileToTypeKey[k];
          if (m >= 0){
            typname = myRecord[m];
            if (!typname.equals("")){
              int l = typname.indexOf('\r');
              if (l>0)typname = typname.substring( l+1);
            }
          }
          protocolFiles += FileString.getNewContents(value, typname, protocolFileNum1);
          if (isFtpDirec || isFtpFile) pendingCount++;
          }
          break;
        default: if (num > VocabulName.getIdentificyFirst()){
          try {
            setTargetValue( value, param, tempMiddle);
          }
          catch (Exception ex) {}
        }
      }
    }
    if (generIds > 0 && stg != null){
        int identCount = VocabulName.getLevelIdCount(level);
        long identificId[] = new long[identCount];
        for (int i=0; i<identCount; i++){
     		String fn = VocabulName.getFieldNameIVT(VocabulName.getLevelIdNum( level,i));
          Persistent identific = (Persistent) tempMiddle.getValue( fn);
          identificId[ i] = (identific!=null)?identific.getId().longValue():0;
        }  
        String genId = session.getSimsIdentifierTemp( level, stg.getId().toString(),
        		stg.getVisibleName(),identificId, "0");
    	tempMiddle.setVisibleName( genId);
    }
    if (dataFileNum1>0) tempMiddle.setDataFiles(dataFiles);
    if (protocolFileNum1>0) tempMiddle.setProtocolFiles(protocolFiles);
    tempMiddle.setPendingX(new Integer( pendingCount));
  }
  public void nextElement( Top tempTop){
    String[] myRecord = myNextRecord;
    String dataFiles ="\r";
    String protocolFiles ="\r";
    dataFileNum1 = 0;
    protocolFileNum1 = 0;
    int pendingCount = 0;
    for (int k = startNum; k < sizeNum; k++){
      String value = myRecord[k];
      TempMetaData param = paramArray[k];
      if (param==null) continue;    //unknown keyword
      int num = param.getValueRowNumber();
      switch(num){
        case 0: if (k==topNum) tempTop.setVisibleName(value); break;
        case 1: tempTop.setComment(value); break;
        case Fieldname.DATAFILESnum: if (!value.equals("")){  //datafile
          dataFileNames[ dataFileNum1++] = value;
          if (isFtpFile){
            int l = value.indexOf('\r');
            value = value.substring( 0,l);
          }
          String typname = dataType;
          int m = fileToTypeKey[k];
          if (m >= 0){
            typname = myRecord[m];
            if (!typname.equals("")){
              int l = typname.indexOf('\r');
              if (l>0)typname = typname.substring( l+1);
            }
          }
          dataFiles += FileString.getNewContents(value, typname, dataFileNum1);
          if (isFtpDirec || isFtpFile) pendingCount++;
          }
          break;
        case Fieldname.PROTOCOLnum: if (!value.equals("")){  //protocolfile
          protocolFileNames[ protocolFileNum1++] = value;
          if (isFtpFile){
            int l = value.indexOf('\r');
            value = value.substring( 0,l);
          }
          String typname = protocolType;
          int m = fileToTypeKey[k];
          if (m >= 0){
            typname = myRecord[m];
            if (!typname.equals("")){
              int l = typname.indexOf('\r');
              if (l>0)typname = typname.substring( l+1);
            }
          }
          protocolFiles += FileString.getNewContents(value, typname, protocolFileNum1);
          if (isFtpDirec || isFtpFile) pendingCount++;
          }
          break;
        default: if (num > VocabulName.getIdentificyFirst()){
          try {
            setTargetValue( value, param, tempTop);
          }
          catch (Exception ex) {}
        }
      }
    }
    if (generIds > 0) {
    	generNum++;	
        String xyz = session.getTopIdentifierNew(generNum);
        tempTop.setVisibleName( xyz);
    }
    if (dataFileNum1>0) tempTop.setDataFiles(dataFiles);
    if (protocolFileNum1>0) tempTop.setProtocolFiles(protocolFiles);
    tempTop.setPendingX(new Integer( pendingCount));
  }
//----------------------------------------------------------
//---------Iterator while create export string---------------------
//----------------------------------------------------------
  public void startExportIterator(){
    recordIterator = recordList.iterator();
    errorIterator = errorList.iterator();
  }

  public boolean hasNextExportElement(){
    boolean xyz = recordIterator.hasNext();
    return xyz;
  }

  public String nextExportElement(){
    StringBuffer xyz = new StringBuffer();
    String[] myRecord = (String[])recordIterator.next();
    byte[] myError = (byte[])errorIterator.next();
    boolean ef = false;
    for (int i = startNum; i < sizeNum; i++){
      String value = myRecord[i];
      if (!value.equals("")){
        int l = value.indexOf('\r');
        if (l > 0)
          appendString(xyz, value.substring(0, l));
        else
          appendString(xyz, value);
      }
      if (myError[i]>100)
        xyz.append("<warning:")
           .append(errorMessage[myError[i]-100])
           .append(">");
      else
      if (myError[i]>0){
        ef = true;
        xyz.append("<error:")
            .append(errorMessage[myError[i]])
            .append(">");
      }
      xyz.append('\t');
    }
    if (myError[sizeNum] > 0){
      if (myError[sizeNum]>100)
        xyz.append("<warning:")
           .append(errorMessage[myError[sizeNum]-100]);
      else
      xyz.append("<error:")
          .append(errorMessage[myError[sizeNum]]);
      xyz.append(">");
    }
    else
    if (ef)
      xyz.append("NOK");
    else
      xyz.append("OK");
    return xyz.toString();
  }
//----------------------------------------------------------
//----------------------------------------------------------
  public void ProcessFiles( Bottom bottom){//used by session.AddBatchAssay
     File directory, permFile; String fileName;
     directory = session.getProtocolDirectory();
     for (int i = 0; i < protocolFileNum1;){
       String value = protocolFileNames[ i++];
       fileName = FileString.getNewFileName( 2, false, bottom.getId(),i);
       permFile = new File(directory, fileName);
       if (isFtpDirec){
         File tfile = new File( ftpDirec, value);
         PendingTask pendingProtocol = new PendingTask();
         pendingProtocol.setTaskType(new Long(0));
         pendingProtocol.setFromFile( tfile.getAbsolutePath());
         pendingProtocol.setToFile(permFile.getAbsolutePath());
         session.addPendingTask(pendingProtocol, bottom);
       }
       else
       if (isFtpFile){
         int l = value.indexOf('\r');
         String zipNum = value.substring( l + 1);
         value = value.substring( 0,l);
         PendingTask pendingProtocol = new PendingTask();
         pendingProtocol.setTaskType(new Long(zipNum));
         pendingProtocol.setFromFile( ftpFile.getAbsolutePath());
         pendingProtocol.setAttribute1( value);
         pendingProtocol.setToFile(permFile.getAbsolutePath());
         session.addPendingTask(pendingProtocol, bottom);
       }
       else{
   	     File zipFile = (zipType==2)?tarFile:session.getZipTempFile();
         ZipProcessor.getFile(zipFile, value, permFile, zipType);
       }
     }
     directory = session.getDataDirectory();
     for (int i = 0; i < dataFileNum1;){
       String value = dataFileNames[ i++];
       fileName = FileString.getNewFileName( 2, true, bottom.getId(),i);
       permFile = new File( directory, fileName);
       if (isFtpDirec){
         File tfile = new File( ftpDirec, value);
         PendingTask pendingData = new PendingTask();
         pendingData.setTaskType(new Long(0));
         pendingData.setFromFile( tfile.getAbsolutePath());
         pendingData.setToFile(permFile.getAbsolutePath());
         session.addPendingTask(pendingData, bottom);
       }
       else
       if (isFtpFile){
         int l = value.indexOf('\r');
         String zipNum = value.substring( l + 1);
         value = value.substring( 0,l);
         PendingTask pendingData = new PendingTask();
         pendingData.setTaskType(new Long(zipNum));
         pendingData.setFromFile( ftpFile.getAbsolutePath());
         pendingData.setAttribute1( value);
         pendingData.setToFile(permFile.getAbsolutePath());
         session.addPendingTask(pendingData, bottom);
       }
       else{
   	     File zipFile = (zipType==2)?tarFile:session.getZipTempFile();
         ZipProcessor.getFile(zipFile, value, permFile, zipType);
       }
     }
  }
  public void ProcessFiles( Middle middle){//used by session.AddBatchStudyGroup
     File directory, permFile; String fileName;
     directory = session.getProtocolDirectory();
     for (int i = 0; i < protocolFileNum1;){
       String value = protocolFileNames[ i++];
       fileName = FileString.getNewFileName( 1, false, middle.getId(),i);
       permFile = new File(directory, fileName);
       if (isFtpDirec){
         File tfile = new File( ftpDirec, value);
         PendingTask pendingProtocol = new PendingTask();
         pendingProtocol.setTaskType(new Long(0));
         pendingProtocol.setFromFile( tfile.getAbsolutePath());
         pendingProtocol.setToFile(permFile.getAbsolutePath());
         session.addPendingTask(pendingProtocol, middle);
       }
       else
       if (isFtpFile){
         int l = value.indexOf('\r');
         String zipNum = value.substring( l + 1);
         value = value.substring( 0,l);
         PendingTask pendingProtocol = new PendingTask();
         pendingProtocol.setTaskType(new Long(zipNum));
         pendingProtocol.setFromFile( ftpFile.getAbsolutePath());
         pendingProtocol.setAttribute1( value);
         pendingProtocol.setToFile(permFile.getAbsolutePath());
         session.addPendingTask(pendingProtocol, middle);
       }
       else{
   	     File zipFile = (zipType==2)?tarFile:session.getZipTempFile();
         ZipProcessor.getFile(zipFile, value, permFile, zipType);
       }
     }
     directory = session.getDataDirectory();
     for (int i = 0; i < dataFileNum1;){
       String value = dataFileNames[ i++];
       fileName = FileString.getNewFileName( 1, true, middle.getId(),i);
       permFile = new File( directory, fileName);
       if (isFtpDirec){
         File tfile = new File( ftpDirec, value);
         PendingTask pendingData = new PendingTask();
         pendingData.setTaskType(new Long(0));
         pendingData.setFromFile( tfile.getAbsolutePath());
         pendingData.setToFile(permFile.getAbsolutePath());
         session.addPendingTask(pendingData, middle);
       }
       else
       if (isFtpFile){
         int l = value.indexOf('\r');
         String zipNum = value.substring( l + 1);
         value = value.substring( 0,l);
         PendingTask pendingData = new PendingTask();
         pendingData.setTaskType(new Long(zipNum));
         pendingData.setFromFile( ftpFile.getAbsolutePath());
         pendingData.setAttribute1( value);
         pendingData.setToFile(permFile.getAbsolutePath());
         session.addPendingTask(pendingData, middle);
       }
       else{
   	     File zipFile = (zipType==2)?tarFile:session.getZipTempFile();
         ZipProcessor.getFile(zipFile, value, permFile, zipType);
       }
     }
  }
  public void ProcessFiles(Top top){//used by session.AddBatchStudyGroup
     File directory, permFile; String fileName;
     directory = session.getProtocolDirectory();
     for (int i = 0; i < protocolFileNum1;){
       String value = protocolFileNames[ i++];
       fileName = FileString.getNewFileName( 0, false, top.getId(),i);
       permFile = new File(directory, fileName);
       if (isFtpDirec){
         File tfile = new File( ftpDirec, value);
         PendingTask pendingProtocol = new PendingTask();
         pendingProtocol.setTaskType(new Long(0));
         pendingProtocol.setFromFile( tfile.getAbsolutePath());
         pendingProtocol.setToFile(permFile.getAbsolutePath());
         session.addPendingTask(pendingProtocol, top);
       }
       else
       if (isFtpFile){
         int l = value.indexOf('\r');
         String zipNum = value.substring( l + 1);
         value = value.substring( 0,l);
         PendingTask pendingProtocol = new PendingTask();
         pendingProtocol.setTaskType(new Long(zipNum));
         pendingProtocol.setFromFile( ftpFile.getAbsolutePath());
         pendingProtocol.setAttribute1( value);
         pendingProtocol.setToFile(permFile.getAbsolutePath());
         session.addPendingTask(pendingProtocol, top);
       }
       else{
   	     File zipFile = (zipType==2)?tarFile:session.getZipTempFile();
         ZipProcessor.getFile(zipFile, value, permFile, zipType);
       }
     }
     directory = session.getDataDirectory();
     for (int i = 0; i < dataFileNum1;){
       String value = dataFileNames[ i++];
       fileName = FileString.getNewFileName( 0, true, top.getId(),i);
       permFile = new File( directory, fileName);
       if (isFtpDirec){
         File tfile = new File( ftpDirec, value);
         PendingTask pendingData = new PendingTask();
         pendingData.setTaskType(new Long(0));
         pendingData.setFromFile( tfile.getAbsolutePath());
         pendingData.setToFile(permFile.getAbsolutePath());
         session.addPendingTask(pendingData, top);
       }
       else
       if (isFtpFile){
         int l = value.indexOf('\r');
         String zipNum = value.substring( l + 1);
         value = value.substring( 0,l);
         PendingTask pendingData = new PendingTask();
         pendingData.setTaskType(new Long(zipNum));
         pendingData.setFromFile( ftpFile.getAbsolutePath());
         pendingData.setAttribute1( value);
         pendingData.setToFile(permFile.getAbsolutePath());
         session.addPendingTask(pendingData, top);
       }
       else{
   	     File zipFile = (zipType==2)?tarFile:session.getZipTempFile();
         ZipProcessor.getFile(zipFile, value, permFile, zipType);
       }
     }
  }
  
}

