package molpage.com;

import javax.servlet.http.*;
import java.util.*;

public final class SessionListener implements HttpSessionListener {
  private static HashMap<HttpSession,UserHttpSess> userSessions =
	  new HashMap<HttpSession,UserHttpSess>();

  public void sessionCreated(HttpSessionEvent e) {
    HttpSession httpSess = e.getSession();
    synchronized(userSessions)
    {
     if(!userSessions.containsKey(httpSess))
      userSessions.put(httpSess, new UserHttpSess(httpSess));
    }
  }

  public void sessionDestroyed(HttpSessionEvent e) {
    UserHttpSess tmpSessConfObj = (UserHttpSess) userSessions.get(e.getSession());
    if (tmpSessConfObj != null) {
      tmpSessConfObj.closeAll();
      userSessions.remove(e.getSession());
    }
  }

  public static int getConcurrentUsers() {
    return userSessions.size();
  }

  public static UserHttpSess getUserHttpSessObject(HttpSession s) {
    return (UserHttpSess) userSessions.get(s);
  }
}
