package molpage.com;

public final class ViewPersonManager {

    private UserHttpSess parent;
    private int total;
    private int first;
    private int step;
    private int personCount;

    public ViewPersonManager(UserHttpSess tmpHttpSessObj) {
      parent = tmpHttpSessObj;
      step = 0;
      total = -1;
      first = 0;
    }

    public void clearValues() {
      total = -1;
      first = 0;
      step = parent.getViewLimit();
    }

    public int getPersonTotal() throws Exception {
      if ((step > 0) && (total < 0))
        total = parent.getAllPersonsCount();
      return total;
    }

    public void changePersonTotal( int diff) {
      total += diff;
    }

    public void setPersonCount( int val) {
      personCount = val;
      if (total < personCount) total = personCount;
    }

    public boolean hasPersonPrevious() {
      return (step > 0) && (first > 0);
    }

    public void setPersonPrevious() {
      first -= step;
      if (first < 0) first = 0;
    }

    public boolean hasPersonNext() {
      return (step > 0) && (first + step < total - 1);
    }

    public void setPersonNext() {
      first += step;
      if (first >= total) setPersonPrevious();
    }

    public void setPersonFirst() {
      first = 0;
    }

    public void setPersonLast() {
      first = total - step;
      if (first < 0) first = 0;
    }

    public int getPersonStep() {
      return step;
    }

    public int getPersonCurrent() {
      return first;
    }

    public String getPersonControlString(boolean down) {
      StringBuffer xyz = new StringBuffer();
      xyz.append("&nbsp;");
      if (total>0){
    	if (down) xyz.append(
  "<a href='javascript:jumpFocus(\"bottomLine\")'><img border='0' src='./images/down_d_10_b.gif' title='bottom of page' alt=''></a>"
        ); else xyz.append(	
  "<a href='javascript:scrollTo(0,0)'><img border='0' src='./images/up_d_10_b.gif' title='top of page' alt=''></a>"
        );xyz.append("&nbsp;");
      }
      if ((step > 0) && (total > step)) {
        if (first > 0){
          xyz.append("<button type='button' onclick='gotoFirst()' title='first' class='lines'>")
              .append("<img border='0' src='./images/left_d_10_b.gif' title='first' alt=''>")
              .append("</button>");
          xyz.append("<button type='button' onclick='gotoPrevious()' title='previous' class='lines'>")
              .append("<img border='0' src='./images/left_10_b.gif' title='previous' alt=''>")
              .append("</button>");
        }
       else{
         xyz.append("<button type='button' disabled class='lines'>")
             .append("<img border='0' src='./images/left_d_10_h.gif' alt=''>")
             .append("</button>");
         xyz.append("<button type='button' disabled class='lines'>")
             .append("<img border='0' src='./images/left_10_h.gif' alt=''>")
             .append("</button>");
       }
        xyz.append(first+1)
           .append('-')
           .append(first+personCount)
           .append("&nbsp;of&nbsp;")
           .append(total)
           .append("&nbsp;items&nbsp;");
         if (first + personCount < total){
           xyz.append("<button type='button' onclick='gotoNext()' title='next' class='lines'>")
               .append("<img border='0' src='./images/right_10_b.gif' title='next' alt=''>")
               .append("</button>");
           xyz.append("<button type='button' onclick='gotoLast()' title='last' class='lines'>")
               .append("<img border='0' src='./images/right_d_10_b.gif' title='last' alt=''>")
               .append("</button>");
         }
        else{
          xyz.append("<button type='button' disabled class='lines'>")
              .append("<img border='0' src='./images/right_10_h.gif' alt=''>")
              .append("</button>");
          xyz.append("<button type='button' disabled class='lines'>")
              .append("<img border='0' src='./images/right_d_10_h.gif' alt=''>")
              .append("</button>");
        }
      }
      else
        xyz.append(total)
           .append("&nbsp;items&nbsp;");
      return xyz.toString();
    }

}
