package sims.hibernate;

import java.io.File;
import java.text.DecimalFormat;
import java.text.NumberFormat;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;


public final class VocabulName {
  public VocabulName() {
    try {
      jbInit();
    } catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  private static String thisName = "sims.hibernate.";
//-----------------------------------------------
//----------  start of specification  -----------
//-----------------------------------------------
  private static String[][] mainName = {{},};
  private static String[][] dependencyName = {{},};
  private static String[][] identificyName = {{},};
  private static String[][] vocabularyName = {{},};
  private static int dependencyCount = 0;
  private static int identificyCount = 0;
  private static int vocabularyCount = 0;
  private static int topStringCount = 0;
  private static int middleStringCount = 0;
  private static int bottomStringCount = 0;
  private static int topIntegerCount = 0;
  private static int middleIntegerCount = 0;
  private static int bottomIntegerCount = 0;
  private static int topFloatCount = 0;
  private static int middleFloatCount = 0;
  private static int bottomFloatCount = 0;
  private static int topDateCount = 0;
  private static int middleDateCount = 0;
  private static int bottomDateCount = 0;
  
  private static int myUplCount = 0;
  private static String[] myParamName = {};
  private static int[] myParamNum = {};

//this method for metadatamanger
  public static String getUploadName(int paramNum){
    for (int i = 0; i < myUplCount; i++) {
      if (myParamNum[i]==paramNum)return myParamName[i];	
    }
    return null;  
  }
//---------------------------------------------------------------
  private static int[] levelIdCount = {0,0,0};
  private static int[] levelPostfixType = {1,1,2};
  private static String[][] levelIdDelimiter = {{"-","-","-","-"},{"","","",""},{"","","",""}};
  private static int[][] levelIdNum = {{0,0,0},{0,0,0},{0,0,0}};
  public static int getLevelIdCount( int level){
	  return levelIdCount[ level];
  }
  public static int getLevelPostfixType( int level){
	  return levelPostfixType[ level];
  }
  public static String getLevelIdDelimiter( int level, int num){
	  return levelIdDelimiter[ level][num];
  }
  public static int getLevelIdNum( int level, int num){
	  return levelIdNum[ level][num];
  }

  private static int getNumber( String str) throws Exception {
	int result = 0;
	if (str!=null){
	  int n = MyUtil.getIntegerValue(str);
	  if (n>0&&n<80) result = n;
	}
	return result;
  }
  private static int processMainNames( Element root) throws Exception {
   int result = 0;
   mainName = new String[3][3];
   NodeList nodeLst1 = root.getElementsByTagName(XMLTags.XBottom);
   int k = nodeLst1.getLength();
   if (k == 1){
     Element bottom = (Element) nodeLst1.item(0);
     mainName[2][0] = bottom.getAttribute(XMLTags.Xplural);
     mainName[2][1] = bottom.getAttribute(XMLTags.Xsingular);
     mainName[2][2] = bottom.getAttribute(XMLTags.Xprefix);
     bottomStringCount = getNumber(bottom.getAttribute(XMLTags.XstringNumb));
     bottomIntegerCount = getNumber(bottom.getAttribute(XMLTags.XintegerNumb));
     bottomFloatCount = getNumber(bottom.getAttribute(XMLTags.XfloatNumb));
     bottomDateCount = getNumber(bottom.getAttribute(XMLTags.XdateNumb));
   }
   nodeLst1 = root.getElementsByTagName(XMLTags.XMiddle);
   k = nodeLst1.getLength();
   if (k == 1){
     Element middle = (Element) nodeLst1.item(0);
     mainName[1][0] = middle.getAttribute(XMLTags.Xplural);
     mainName[1][1] = middle.getAttribute(XMLTags.Xsingular);
     mainName[1][2] = middle.getAttribute(XMLTags.Xprefix);
     middleStringCount = getNumber(middle.getAttribute(XMLTags.XstringNumb));
     middleIntegerCount = getNumber(middle.getAttribute(XMLTags.XintegerNumb));
     middleFloatCount = getNumber(middle.getAttribute(XMLTags.XfloatNumb));
     middleDateCount = getNumber(middle.getAttribute(XMLTags.XdateNumb));
   }
   nodeLst1 = root.getElementsByTagName(XMLTags.XTop);
   k = nodeLst1.getLength();
   if (k == 1){
     Element top = (Element) nodeLst1.item(0);
     mainName[0][0] = top.getAttribute(XMLTags.Xplural);
     mainName[0][1] = top.getAttribute(XMLTags.Xsingular);
     mainName[0][2] = top.getAttribute(XMLTags.Xprefix);
     topStringCount = getNumber(top.getAttribute(XMLTags.XstringNumb));
     topIntegerCount = getNumber(top.getAttribute(XMLTags.XintegerNumb));
     topFloatCount = getNumber(top.getAttribute(XMLTags.XfloatNumb));
     topDateCount = getNumber(top.getAttribute(XMLTags.XdateNumb));
   }
   return result;
  }

  private static int processUploadNames( Element root) throws Exception {
    int result = 0;
    NodeList nodeLst1 = root.getElementsByTagName(XMLTags.XUploadName);
    myUplCount = nodeLst1.getLength();
    if (myUplCount > 0){
      myParamName = new String[myUplCount];
      myParamNum = new int[myUplCount];
      for (int i = 0; i < myUplCount; i++) {
        Element group = (Element) nodeLst1.item(i);
        String columnname = group.getAttribute(XMLTags.Xcolumn);
        String uploadname = group.getAttribute(XMLTags.Xupload);
        int m = Fieldname.getRowNumber(columnname);
        if (m >= 0) {
          myParamNum[i] = m; myParamName[i] = uploadname;
        }
      }
    }
    return result;
  }
  
  private static int processVocabularies( Element root) throws Exception {
    int result = 0; int vmax = 0;
    NodeList nodeLst1 = root.getElementsByTagName(XMLTags.XVocabulary);
	int myCount = nodeLst1.getLength();
	if (myCount > 0){
	  for (int i = 0; i < myCount; i++) {
	    Element group = (Element) nodeLst1.item(i);
	    String numb = group.getAttribute(XMLTags.Xseq_numb);
	    int n = MyUtil.getIntegerValue(numb);
	    if (n>0&&n<80){
	      if (n>vmax)vmax = n;	
	    } 
	  }
	  vocabularyCount = vmax++;
	  vocabularyName = new String [vmax][2];
	  for (int i = 0; i < myCount; i++) {
	    Element group = (Element) nodeLst1.item(i);
	    String numb = group.getAttribute(XMLTags.Xseq_numb);
	    int n = MyUtil.getIntegerValue(numb);
	    if (n>0&&n<vmax){
	      vocabularyName[n][0] = group.getAttribute(XMLTags.Xtable);	
	      vocabularyName[n][1] = group.getAttribute(XMLTags.Xitem);
	    }
	  }  
	}
    return result;
  }
  private static int processIdentificies( Element root) throws Exception {
    int result = 0; int vmax = 0;
    NodeList nodeLst1 = root.getElementsByTagName(XMLTags.XIdentificy);
	int myCount = nodeLst1.getLength();
	if (myCount > 0){
	  for (int i = 0; i < myCount; i++) {
	    Element group = (Element) nodeLst1.item(i);
	    String numb = group.getAttribute(XMLTags.Xseq_numb);
        int n = MyUtil.getIntegerValue(numb);
	    if (n>0&&n<10){
	      if (n>vmax)vmax = n;	
	    } 
	  }
	  identificyCount = vmax++;
	  identificyName = new String [vmax][2];
	  for (int i = 0; i < myCount; i++) {
	    Element group = (Element) nodeLst1.item(i);
	    String numb = group.getAttribute(XMLTags.Xseq_numb);
	    int n = MyUtil.getIntegerValue(numb);
	    if (n>0&&n<vmax){
	      identificyName[n][0] = group.getAttribute(XMLTags.Xtable);	
	      identificyName[n][1] = group.getAttribute(XMLTags.Xitem);
	    }
	  }  
	}
	return result;
  }
  private static int processDependencies( Element root) throws Exception {
    int result = 0; int vmax = 0;
    NodeList nodeLst1 = root.getElementsByTagName(XMLTags.XDependency);
	int myCount = nodeLst1.getLength();
	if (myCount > 0){
	  for (int i = 0; i < myCount; i++) {
	    Element group = (Element) nodeLst1.item(i);
	    String numb = group.getAttribute(XMLTags.Xseq_numb);
        int n = MyUtil.getIntegerValue(numb);
	    if (n>0&&n<10){
	      if (n>vmax)vmax = n;	
	    } 
	  }
	  dependencyCount = vmax++;
	  dependencyName = new String [vmax][5];
		  for (int i = 0; i < myCount; i++) {
		    Element group = (Element) nodeLst1.item(i);
		    String numb = group.getAttribute(XMLTags.Xseq_numb);
		    int n = MyUtil.getIntegerValue(numb);
		    if (n>0&&n<vmax){
		      dependencyName[n][0] = group.getAttribute(XMLTags.Xtable);	
		      dependencyName[n][1] = group.getAttribute(XMLTags.Xindependent);
		      dependencyName[n][2] = group.getAttribute(XMLTags.Xdependent);
		      dependencyName[n][3] = group.getAttribute(XMLTags.XindependentClass);
		      dependencyName[n][4] = group.getAttribute(XMLTags.XdependentClass);
		    }
		  }  
		}
		return result;
	  }
  private static int processIdentifDetails( int level, Element bottom) throws Exception {
    int result = 0;
    for (int i = 0; i < 4; i++){
      String param = MyUtil.getParameterName0("s", i+1);
      String delim = bottom.getAttribute(param);
      levelIdDelimiter[level][i] = (delim==null)?"":delim;
    }
    levelIdCount[level]=0;
    for (int i = 0; i < 3; i++){
      String param = MyUtil.getParameterName0("ivt", i+1);
      String ivt = bottom.getAttribute(param);
      int ivtNum = MyUtil.getIntegerValue(ivt);
      if (ivtNum<1 || ivtNum>identificyCount) break;
      levelIdNum[level][i] = ivtNum;
      levelIdCount[level]++;
    }
    String numb = bottom.getAttribute("ptype");
    int ptype = MyUtil.getIntegerValue(numb);
    levelPostfixType[level] = (ptype==2)?2:1;
	return result;
  }
  private static int processIdStructure( Element root) throws Exception {
    int result = 0; 
    NodeList nodeLst1 = root.getElementsByTagName(XMLTags.XBottom);
    int num = nodeLst1.getLength();
    if ( num == 1) processIdentifDetails( 2, (Element)nodeLst1.item(0));
    nodeLst1 = root.getElementsByTagName(XMLTags.XMiddle);
    num = nodeLst1.getLength();
    if ( num == 1) processIdentifDetails( 1, (Element)nodeLst1.item(0));
    nodeLst1 = root.getElementsByTagName(XMLTags.XTop);
    num = nodeLst1.getLength();
    if ( num == 1) processIdentifDetails( 0, (Element)nodeLst1.item(0));
	return result;
  }
  private static int processRoot( Element root) throws Exception{
    int result = 0;
    String version = root.getAttribute(XMLTags.Xversion);
    if (version==null||!version.equals("1.17")){
      return 1;
    }
    NodeList nodeLst1 = root.getElementsByTagName(XMLTags.XUploadNames);
    int num = nodeLst1.getLength();
    if ( num != 1){
      return 1;
    }
    result = processUploadNames( (Element)nodeLst1.item(0));
    nodeLst1 = root.getElementsByTagName(XMLTags.XMainNames);
	num = nodeLst1.getLength();
    if ( num != 1){
      return 1;
    }
    result = processMainNames( (Element)nodeLst1.item(0));
    nodeLst1 = root.getElementsByTagName(XMLTags.XVocabularies);
	num = nodeLst1.getLength();
    if (num==1) processVocabularies( (Element)nodeLst1.item(0));
    nodeLst1 = root.getElementsByTagName(XMLTags.XIdentificies);
	num = nodeLst1.getLength();
    if (num==1) processIdentificies( (Element)nodeLst1.item(0));
    nodeLst1 = root.getElementsByTagName(XMLTags.XDependencies);
	num = nodeLst1.getLength();
    if (num==1) processDependencies( (Element)nodeLst1.item(0));
    nodeLst1 = root.getElementsByTagName(XMLTags.XIdStructure);
	num = nodeLst1.getLength();
    if (num==1) processIdStructure( (Element)nodeLst1.item(0));
    return result;
  }

  public static int processConstants( File systemConst){
    int result = 0;
    try {
      DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
      DocumentBuilder db = dbf.newDocumentBuilder();
      Document doc = db.parse(systemConst);
      Element root = doc.getDocumentElement();
      root.normalize();
      result = processRoot( root);
      stringCount = Math.max(topStringCount,Math.max(middleStringCount,bottomStringCount));
      integerCount = Math.max(topIntegerCount,Math.max(middleIntegerCount,bottomIntegerCount));
      floatCount = Math.max(topFloatCount,Math.max(middleFloatCount,bottomFloatCount));
      dateCount = Math.max(topDateCount,Math.max(middleDateCount,bottomDateCount));
      vocabularyFirst = identificyFirst + identificyCount;
      stringFirst = vocabularyFirst + vocabularyCount;
      integerFirst = stringFirst + stringCount;
      floatFirst = integerFirst + integerCount;
      dateFirst = floatFirst + floatCount;
      totalCount = dateFirst + dateCount + 1; //+1!!!
    }
    catch (Exception e) {
/*
   	if (e!=null){
      java.io.CharArrayWriter cw = new java.io.CharArrayWriter();
      java.io.PrintWriter pw = new java.io.PrintWriter(cw,true);
      e.printStackTrace(pw);
      Util.writeAccessLog(cw.toString(),"","");
*/      
     result = 1;
    }
    return result;
  }

//--------------------------------------------------
//--------------------------------------------------
  private static final int identificyFirst = 20;
  private static int vocabularyFirst;
  private static int stringFirst;
  private static int integerFirst;
  private static int floatFirst;
  private static int dateFirst;
  private static int totalCount; //+1!!!
  private static int stringCount = 0;
  private static int integerCount = 0;
  private static int floatCount = 0;
  private static int dateCount = 0;
/*
public static void init(){
  stringCount = Math.max(topStringCount,Math.max(middleStringCount,bottomStringCount));
  integerCount = Math.max(topIntegerCount,Math.max(middleIntegerCount,bottomIntegerCount));
  floatCount = Math.max(topFloatCount,Math.max(middleFloatCount,bottomFloatCount));
  dateCount = Math.max(topDateCount,Math.max(middleDateCount,bottomDateCount));
  vocabularyFirst = identificyFirst + identificyCount;
  stringFirst = vocabularyFirst + vocabularyCount;
  integerFirst = stringFirst + stringCount;
  floatFirst = integerFirst + integerCount;
  dateFirst = floatFirst + floatCount;
  totalCount = dateFirst + dateCount + 1; //+1!!!
}
*/
public static String getIdentificyName( int inpDate){
   return identificyName[inpDate][0];
}
public static String getIdentificyFieldName( int inpDate){
   return identificyName[inpDate][1];
}
public static String getFieldNameIVT( int inpDate){
   DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
   snf.applyPattern("ivt00");
   return snf.format(inpDate);
}
public static String getIdentificyClassName( int inpDate){
   DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
   snf.applyPattern("IVT00");
   return thisName+snf.format(inpDate);
}
public static Class getIdentificyClass( int inpDate) throws ClassNotFoundException {
   DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
   snf.applyPattern("IVT00");
   return Class.forName(thisName+snf.format(inpDate));
}
public static String getSetMethodNameIVT( int inpDate){
   DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
   snf.applyPattern("setIvt00");
   return snf.format(inpDate);
}
public static String getGetMethodNameIVT( int inpDate){
   DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
   snf.applyPattern("getIvt00");
   return snf.format(inpDate);
}
//------ end of identificies ------------------
//------ start of dependencies ------------------
  public static int getDependencyCount() {
    return dependencyCount;
  }
  public static String getDependencyName( int inpDate){
     return dependencyName[inpDate][0];
  }
  public static String getDependencyClassName( int inpDate){
     DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
     snf.applyPattern("DVT00");
     return thisName+snf.format(inpDate);
  }
  public static Class getDependencyClass( int inpDate) throws ClassNotFoundException {
     DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
     snf.applyPattern("DVT00");
     return Class.forName(thisName+snf.format(inpDate));
  }
  public static String getServerName( int inpDate){
     return dependencyName[inpDate][1];
  }
  public static String getClientName( int inpDate){
     return dependencyName[inpDate][2];
  }
  public static String getServerClassName( int inpDate) throws ClassNotFoundException {
     return thisName+dependencyName[inpDate][3];
   }
  public static Class getServerClass( int inpDate) throws ClassNotFoundException {
     return Class.forName(thisName+dependencyName[inpDate][3]);
   }
   public static String getClientClassName( int inpDate) throws ClassNotFoundException {
     return thisName+dependencyName[inpDate][4];
   }
  public static Class getClientClass( int inpDate) throws ClassNotFoundException {
    return Class.forName(thisName+dependencyName[inpDate][4]);
  }
//------ end of dependencies ------------------
//------ data fields -------------------
  public static int getTotalCount() {
    return totalCount;
  }
  public static int getIdentificyCount() {
    return identificyCount;
  }
  public static int getIdentificyFirst() {
    return identificyFirst;
  }
  public static int getVocabularyCount() {
    return vocabularyCount;
  }
  public static int getVocabularyFirst() {
    return vocabularyFirst;
  }
  public static int getTopStringCount() {
    return topStringCount;
  }
  public static int getMiddleStringCount() {
    return middleStringCount;
  }
  public static int getBottomStringCount() {
    return bottomStringCount;
  }
  public static int getStringCount( int level) {
    return (level==2)?bottomStringCount:(level==1)?middleStringCount:topStringCount;
  }
  public static int getStringFirst() {
    return stringFirst;
  }
  public static int getTopIntegerCount() {
    return topIntegerCount;
  }
  public static int getMiddleIntegerCount() {
    return middleIntegerCount;
  }
  public static int getBottomIntegerCount() {
    return bottomIntegerCount;
  }
  public static int getIntegerCount( int level) {
    return (level==2)?bottomIntegerCount:(level==1)?middleIntegerCount:topIntegerCount;
  }
  public static int getIntegerFirst() {
    return integerFirst;
  }
  public static int getTopFloatCount() {
    return topFloatCount;
  }
  public static int getMiddleFloatCount() {
    return middleFloatCount;
  }
  public static int getBottomFloatCount() {
    return bottomFloatCount;
  }
  public static int getFloatCount( int level) {
    return (level==2)?bottomFloatCount:(level==1)?middleFloatCount:topFloatCount;
  }
  public static int getFloatFirst() {
    return floatFirst;
  }
  public static int getTopDateCount() {
    return topDateCount;
  }
  public static int getMiddleDateCount() {
    return middleDateCount;
  }
  public static int getBottomDateCount() {
    return bottomDateCount;
  }
  public static int getDateCount( int level) {
    return (level==2)?bottomDateCount:(level==1)?middleDateCount:topDateCount;
  }
  public static int getDateFirst() {
    return dateFirst;
  }
//-------------------------------------------
  public static String getVocabularyName( int num) {
    return vocabularyName[num][0];
  }
  public static String getVocabularyFieldName( int num) {
    return vocabularyName[num][1];
  }
//Vocabulary type fields
  public static String getFieldNameVT( int inpDate){
     DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
     snf.applyPattern("vt00");
     return snf.format(inpDate);
  }
  public static String getClassNameVT( int inpDate){
     DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
     snf.applyPattern("VT00");
     return thisName+snf.format(inpDate);
  }
  public static Class getVocabularyClass( int inpDate) throws ClassNotFoundException {
     DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
     snf.applyPattern("VT00");
     return Class.forName(thisName+snf.format(inpDate));
  }
  public static String getSetMethodNameVT( int inpDate){
     DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
     snf.applyPattern("setVt00");
     return snf.format(inpDate);
  }
  public static String getGetMethodNameVT( int inpDate){
     DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
     snf.applyPattern("getVt00");
     return snf.format(inpDate);
  }
//String type fields
  public static String getFieldNameST( int inpDate){
     DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
     snf.applyPattern("st00");
     return snf.format(inpDate);
  }
  public static String getSetMethodNameST( int inpDate){
     DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
     snf.applyPattern("setSt00");
     return snf.format(inpDate);
  }
  public static String getGetMethodNameST( int inpDate){
     DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
     snf.applyPattern("getSt00");
     return snf.format(inpDate);
  }
//Integer type fields
    public static String getFieldNameIT( int inpDate){
       DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
       snf.applyPattern("it00");
       return snf.format(inpDate);
    }
    public static String getSetMethodNameIT( int inpDate){
       DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
       snf.applyPattern("setIt00");
       return snf.format(inpDate);
    }
    public static String getGetMethodNameIT( int inpDate){
       DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
       snf.applyPattern("getIt00");
       return snf.format(inpDate);
    }
//Float type fields
    public static String getFieldNameFT( int inpDate){
       DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
       snf.applyPattern("ft00");
       return snf.format(inpDate);
    }
    public static String getSetMethodNameFT( int inpDate){
       DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
       snf.applyPattern("setFt00");
       return snf.format(inpDate);
    }
    public static String getGetMethodNameFT( int inpDate){
       DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
       snf.applyPattern("getFt00");
       return snf.format(inpDate);
    }
//Date type fields
    public static String getFieldNameDT( int inpDate){
       DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
       snf.applyPattern("dt00");
       return snf.format(inpDate);
    }
    public static String getSetMethodNameDT( int inpDate){
       DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
       snf.applyPattern("setDt00");
       return snf.format(inpDate);
    }
    public static String getGetMethodNameDT( int inpDate){
       DecimalFormat snf = (DecimalFormat)NumberFormat.getNumberInstance();
       snf.applyPattern("getDt00");
       return snf.format(inpDate);
    }

  public static String getTopPlural(){ return mainName[0][0];}
  public static String getTopSingular(){ return mainName[0][1];}
  public static String getTopPrefix(){ return mainName[0][2];}
  public static String getMiddlePlural(){ return mainName[1][0];}
  public static String getMiddleSingular(){ return mainName[1][1];}
  public static String getMiddlePrefix(){ return mainName[1][2];}
  public static String getBottomPlural(){ return mainName[2][0];}
  public static String getBottomSingular(){ return mainName[2][1];}
  public static String getBottomPrefix(){ return mainName[2][2];}

  public static int getRowNumber(String key){
  int res = 0;
  if (key.charAt(0)=='i' && key.charAt(1)=='v' && key.charAt(2)=='t'){
    try{
      int x = Integer.parseInt(key.substring(3,5));
      if (x > 0 && x <= VocabulName.getIdentificyCount())
        res = getIdentificyFirst() + x;
    } catch (Exception ex) {
    }
  }
  else
  if (key.charAt(0)=='v' && key.charAt(1)=='t'){
    try{
      int x = Integer.parseInt(key.substring(2,4));
      if (x > 0 && x <= VocabulName.getVocabularyCount())
        res = VocabulName.getVocabularyFirst() + x;
    } catch (Exception ex) {
    }
  }
  else
  if (key.charAt(0)=='s' && key.charAt(1)=='t'){
    try{
      int x = Integer.parseInt(key.substring(2,4));
      if (x > 0 && x <= stringCount)
        res = VocabulName.getStringFirst() + x;
    } catch (Exception ex) {
    }
  }
  else
  if (key.charAt(0)=='i' && key.charAt(1)=='t'){
    try{
      int x = Integer.parseInt(key.substring(2,4));
      if (x > 0 && x <= integerCount)
        res = VocabulName.getIntegerFirst() + x;
    } catch (Exception ex) {
    }
  }
  else
  if (key.charAt(0)=='f' && key.charAt(1)=='t'){
    try{
      int x = Integer.parseInt(key.substring(2,4));
      if (x > 0 && x <= floatCount)
        res = VocabulName.getFloatFirst() + x;
    } catch (Exception ex) {
    }
  }
  else
  if (key.charAt(0)=='d' && key.charAt(1)=='t'){
    try{
      int x = Integer.parseInt(key.substring(2,4));
      if (x > 0 && x <= dateCount)
        res = VocabulName.getDateFirst() + x;
    } catch (Exception ex) {
    }
  }
  return res;
}
/*  
  public static int getRowNumber(String key, int level){
	int res = 0;
	if (key.charAt(0)=='i' && key.charAt(1)=='v' && key.charAt(2)=='t'){
	  try{
	    int x = Integer.parseInt(key.substring(3,5));
	      if (x > 0 && x <= VocabulName.getIdentificyCount())
	        res = getIdentificyFirst() + x;
	      else throw( new Exception());
	    } catch (Exception ex) {
	      Util.writeLog( "Inconsitence of metadata:", key, "");	
	    }
	  }
	  else
	  if (key.charAt(0)=='v' && key.charAt(1)=='t'){
	    try{
	      int x = Integer.parseInt(key.substring(2,4));
	      if (x > 0 && x <= VocabulName.getVocabularyCount())
	        res = VocabulName.getVocabularyFirst() + x;
	      else throw( new Exception());
	    } catch (Exception ex) {
	      Util.writeLog( "Inconsitence of metadata:", key, "");	
	    }
	  }
	  else
	  if (key.charAt(0)=='s' && key.charAt(1)=='t'){
	    try{
	      int x = Integer.parseInt(key.substring(2,4));
	      if (x > 0 && x <= getStringCount(level))
	        res = VocabulName.getStringFirst() + x;
	      else throw( new Exception());
	    } catch (Exception ex) {
	      Util.writeLog( "Inconsitence of metadata:", key, "");	
	    }
	  }
	  else
	  if (key.charAt(0)=='i' && key.charAt(1)=='t'){
	    try{
	      int x = Integer.parseInt(key.substring(2,4));
	      if (x > 0 && x <= getIntegerCount(level))
	        res = VocabulName.getIntegerFirst() + x;
	      else throw( new Exception());
	    } catch (Exception ex) {
	      Util.writeLog( "Inconsitence of metadata:", key, "");	
	    }
	  }
	  else
	  if (key.charAt(0)=='f' && key.charAt(1)=='t'){
	    try{
	      int x = Integer.parseInt(key.substring(2,4));
	      if (x > 0 && x <= getFloatCount(level))
	        res = VocabulName.getFloatFirst() + x;
	      else throw( new Exception());
	    } catch (Exception ex) {
	      Util.writeLog( "Inconsitence of metadata:", key, "");	
	    }
	  }
	  else
	  if (key.charAt(0)=='d' && key.charAt(1)=='t'){
	    try{
	      int x = Integer.parseInt(key.substring(2,4));
	      if (x > 0 && x <= getDateCount(level))
	        res = VocabulName.getDateFirst() + x;
	      else throw( new Exception());
	    } catch (Exception ex) {
	      Util.writeLog( "Inconsitence of metadata:", key, "");	
	    }
	  }
	  return res;
	}
  
  public static int getRowNumberCheck(String key){
    int res = 0;
	if (key.charAt(0)=='i' && key.charAt(1)=='v' && key.charAt(2)=='t'){
	  try{
	    int x = Integer.parseInt(key.substring(3,5));
	    if (x > 0 && x <= VocabulName.getIdentificyCount())
	      res = getIdentificyFirst() + x;
	    else throw( new Exception());
	  } catch (Exception ex) {
	    res = -1;	
	  }
	}
	else
	if (key.charAt(0)=='v' && key.charAt(1)=='t'){
	  try{
	    int x = Integer.parseInt(key.substring(2,4));
	    if (x > 0 && x <= VocabulName.getVocabularyCount())
	      res = VocabulName.getVocabularyFirst() + x;
	    else throw( new Exception());
	  } catch (Exception ex) {
	     res = -1;	
	  }
	}
    else
	if (key.charAt(0)=='s' && key.charAt(1)=='t'){
	  try{
	    int x = Integer.parseInt(key.substring(2,4));
	    if (x > 0 && x <= stringCount)
	      res = VocabulName.getStringFirst() + x;
	    else throw( new Exception());
	  } catch (Exception ex) {
	    res = -1;	
	  }
	}
	else
	if (key.charAt(0)=='i' && key.charAt(1)=='t'){
	  try{
	    int x = Integer.parseInt(key.substring(2,4));
	    if (x > 0 && x <= integerCount)
	      res = VocabulName.getIntegerFirst() + x;
	    else throw( new Exception());
	  } catch (Exception ex) {
	    res = -1;	
	  }
	}
	else
	if (key.charAt(0)=='f' && key.charAt(1)=='t'){
	  try{
	    int x = Integer.parseInt(key.substring(2,4));
	    if (x > 0 && x <= floatCount)
	      res = VocabulName.getFloatFirst() + x;
	    else throw( new Exception());
	  } catch (Exception ex) {
	    res = -1;	
	  }
	}
	else
	if (key.charAt(0)=='d' && key.charAt(1)=='t'){
	  try{
	    int x = Integer.parseInt(key.substring(2,4));
	    if (x > 0 && x <= dateCount)
	      res = VocabulName.getDateFirst() + x;
	    else throw( new Exception());
	  } catch (Exception ex) {
	    res = -1;	
	  }
	}
	return res;
  }
*/  
  public static int getRowNumberCheck(String key, int level){
    int res = 0;
	if (key.charAt(0)=='i' && key.charAt(1)=='v' && key.charAt(2)=='t'){
	  try{
	    int x = Integer.parseInt(key.substring(3,5));
	    if (x > 0 && x <= VocabulName.getIdentificyCount())
	      res = getIdentificyFirst() + x;
	    else throw( new Exception());
	  } catch (Exception ex) {
	    res = -1;	
	  }
	}
	else
	if (key.charAt(0)=='v' && key.charAt(1)=='t'){
	  try{
	    int x = Integer.parseInt(key.substring(2,4));
	    if (x > 0 && x <= VocabulName.getVocabularyCount())
	      res = VocabulName.getVocabularyFirst() + x;
	    else throw( new Exception());
	  } catch (Exception ex) {
	    res = -1;	
	  }
	}
	else
	if (key.charAt(0)=='s' && key.charAt(1)=='t'){
	  try{
	    int x = Integer.parseInt(key.substring(2,4));
	    if (x > 0 && x <= getStringCount(level))
	      res = VocabulName.getStringFirst() + x;
	    else throw( new Exception());
	  } catch (Exception ex) {
	    res = -1;	
	  }
	}
	else
	if (key.charAt(0)=='i' && key.charAt(1)=='t'){
	  try{
	    int x = Integer.parseInt(key.substring(2,4));
	    if (x > 0 && x <= getIntegerCount(level))
	      res = VocabulName.getIntegerFirst() + x;
	    else throw( new Exception());
	  } catch (Exception ex) {
	    res = -1;	
	  }
	}
	else
	if (key.charAt(0)=='f' && key.charAt(1)=='t'){
	  try{
	    int x = Integer.parseInt(key.substring(2,4));
	    if (x > 0 && x <= getFloatCount(level))
	      res = VocabulName.getFloatFirst() + x;
	    else throw( new Exception());
	  } catch (Exception ex) {
	    res = -1;	
	  }
	}
	else
	if (key.charAt(0)=='d' && key.charAt(1)=='t'){
	  try{
	    int x = Integer.parseInt(key.substring(2,4));
	    if (x > 0 && x <= getDateCount(level))
	      res = VocabulName.getDateFirst() + x;
	    else throw( new Exception());
	  } catch (Exception ex) {
	    res = -1;	
	  }
	}
	return res;
  }
  
public static int getNameType(String key){
int res = 0;
if (key.charAt(0)=='i' && key.charAt(1)=='v' && key.charAt(2)=='t'){
  try{
    int x = Integer.parseInt(key.substring(3,5));
    if (x > 0 && x <= VocabulName.getIdentificyCount())
      res = TypeName.IDENTIFICY;
  } catch (Exception ex) {
  }
} else
if (key.charAt(0)=='v' && key.charAt(1)=='t'){
  try{
    int x = Integer.parseInt(key.substring(2,4));
    if (x > 0 && x <= VocabulName.getVocabularyCount())
      res = TypeName.TABLE;
  } catch (Exception ex) {
  }
} else
if (key.charAt(0)=='s' && key.charAt(1)=='t'){
  try{
    int x = Integer.parseInt(key.substring(2,4));
    if (x > 0 && x <= stringCount)
      res = TypeName.STRING;
  } catch (Exception ex) {
  }
} else
if (key.charAt(0)=='i' && key.charAt(1)=='t'){
  try{
    int x = Integer.parseInt(key.substring(2,4));
    if (x > 0 && x <= integerCount)
      res = TypeName.NUMBER;
  } catch (Exception ex) {
  }
} else
if (key.charAt(0)=='f' && key.charAt(1)=='t'){
  try{
    int x = Integer.parseInt(key.substring(2,4));
    if (x > 0 && x <= floatCount)
      res = TypeName.FLOAT;
  } catch (Exception ex) {
  }
} else
if (key.charAt(0)=='d' && key.charAt(1)=='t'){
  try{
    int x = Integer.parseInt(key.substring(2,4));
    if (x > 0 && x <= dateCount)
      res = TypeName.DATETIME;
  } catch (Exception ex) {
  }
}
return res;
}

  private void jbInit() throws Exception {
  }


}
